﻿Type=Service
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Private astream As AsyncStreams
	Private socket As Socket
	Public connected As Boolean
	Private bc As ByteConverter
	Private watchdog As Timer
	Private lastValueTime As Long
End Sub

Sub Service_Create
	bc.LittleEndian = True
	watchdog.Initialize("watchdog", 1000)
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Public Sub Connect(ip As String)
	If astream.IsInitialized Then
		astream.Close
	End If
	socket.Initialize("socket")
	socket.Connect(ip, 51042, 30000)
End Sub

Private Sub Socket_Connected (Successful As Boolean)
	If Successful Then
		connected = True
		astream.Initialize(socket.InputStream, socket.OutputStream, "astream")
		CallSub(Main, "StateChanged")
		watchdog.Enabled = True
		lastValueTime = DateTime.Now
	End If
End Sub

Private Sub Astream_NewData (Buffer() As Byte)
	Dim value As String = bc.stringFromBytes((Buffer),"ASCII")
	Log(value)
	CallSub2(Main, "NewValue", value)
	lastValueTime = DateTime.Now
End Sub

Private Sub Astream_Error
	Log("Disconnected")
	connected = False
	CallSub(Main, "StateChanged")
	watchdog.Enabled = False
End Sub

Private Sub Astream_Terminated
	Astream_Error
End Sub
Private Sub Astream_Write(com As String)
	astream.Write(bc.StringToBytes((com),"ASCII"))
End Sub
Private Sub Watchdog_Tick
	If DateTime.Now - lastValueTime > 10 * DateTime.TicksPerSecond Then
		Log("Watchdog closing connection.")
		If astream.IsInitialized Then astream.Close
		Astream_Error
	End If
End Sub

Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
Public Sub disconnect()
	If astream.IsInitialized Then
		astream.Close
	End If
	socket.close
	
End Sub

